//: C06:MemFun1.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Použití ukazatelů na členské funkce.
#include <algorithm>
#include <functional>
#include <iostream>
#include <vector>
#include "../purge.h"
using namespace std;

class Tvar {
public:
  virtual void vykreslit() = 0;
  virtual ~Tvar() {}
};

class Kruh : public Tvar {
public:
  virtual void vykreslit() { cout << "Kruh::vykreslit()" << endl; }
  ~Kruh() { cout << "Kruh::~Kruh()" << endl; }
};

class Ctverec : public Tvar {
public:
  virtual void vykreslit() { cout << "Ctverec::vykreslit()" << endl; }
  ~Ctverec() { cout << "Ctverec::~Ctverec()" << endl; }
};

int main() {
  vector<Tvar*> vs;
  vs.push_back(new Kruh);
  vs.push_back(new Ctverec);
  for_each(vs.begin(), vs.end(), mem_fun(&Tvar::vykreslit));
  purge(vs);
} ///:~
